package com.ktg.iscs.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ktg.common.core.text.Convert;
import com.ktg.common.utils.DateUtils;
import com.ktg.iscs.domain.IsLockset;
import com.ktg.iscs.domain.vo.lockset.IsLocksetVO;
import com.ktg.iscs.mapper.IsLocksetMapper;
import com.ktg.iscs.service.IIsLocksetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 锁具Service业务层处理
 *
 * @author cgj
 * @date 2024-11-19
 */
@Service
public class IsLocksetServiceImpl extends ServiceImpl<IsLocksetMapper, IsLockset> implements IIsLocksetService
{
    @Autowired
    private IsLocksetMapper isLocksetMapper;

    /**
     * 查询锁具
     *
     * @param locksetId 锁具主键
     * @return 锁具
     */
    @Override
    public IsLockset selectIsLocksetByLocksetId(Long locksetId)
    {
        return isLocksetMapper.selectIsLocksetByLocksetId(locksetId);
    }

    /**
     * 查询锁具列表
     *
     * @param isLockset 锁具
     * @return 锁具
     */
    @Override
    public List<IsLockset> selectIsLocksetList(IsLockset isLockset)
    {
        return isLocksetMapper.selectIsLocksetList(isLockset);
    }

    /**
     * 新增锁具
     *
     * @param isLockset 锁具
     * @return 结果
     */
    @Override
    public int insertIsLockset(IsLockset isLockset)
    {
        // 1.检查挂锁名称是否重复
        List<IsLockset> list = list(Wrappers.<IsLockset>lambdaQuery()
                .eq(IsLockset::getLocksetName, isLockset.getLocksetName()));
        Assert.isFalse(!list.isEmpty(), "该锁具名称已被使用!");
        // 2.检查挂锁编码是否重复
        List<IsLockset> locksets = list(Wrappers.<IsLockset>lambdaQuery()
                .eq(IsLockset::getLocksetCode, isLockset.getLocksetCode()));
        Assert.isFalse(!locksets.isEmpty(), "该锁具编码已被使用!");
        isLockset.setCreateTime(DateUtils.getNowDate());
        return isLocksetMapper.insertIsLockset(isLockset);
    }

    /**
     * 修改锁具
     *
     * @param isLockset 锁具
     * @return 结果
     */
    @Override
    public int updateIsLockset(IsLockset isLockset)
    {
        // 1.检查挂锁名称是否重复
        List<IsLockset> list = list(Wrappers.<IsLockset>lambdaQuery()
                .eq(IsLockset::getLocksetName, isLockset.getLocksetName())
                .ne(IsLockset::getLocksetId, isLockset.getLocksetId()));
        Assert.isFalse(!list.isEmpty(), "该锁具名称已被使用!");
        // 2.检查挂锁编码是否重复
        List<IsLockset> locksets = list(Wrappers.<IsLockset>lambdaQuery()
                .eq(IsLockset::getLocksetCode, isLockset.getLocksetCode())
                .ne(IsLockset::getLocksetId, isLockset.getLocksetId()));
        Assert.isFalse(!locksets.isEmpty(), "该锁具编码已被使用!");
        isLockset.setUpdateTime(DateUtils.getNowDate());
        return isLocksetMapper.updateIsLockset(isLockset);
    }

    /**
     * 批量删除锁具
     *
     * @param locksetIds 需要删除的锁具主键
     * @return 结果
     */
    @Override
    public int deleteIsLocksetByLocksetIds(String locksetIds)
    {
        Assert.notBlank(locksetIds, "请选择需要删除的数据!");
        Long[] longIds = Convert.toLongArray(locksetIds);
        return isLocksetMapper.deleteIsLocksetByLocksetIds(longIds);
    }

    /**
     * 删除锁具信息
     *
     * @param locksetId 锁具主键
     * @return 结果
     */
    @Override
    public int deleteIsLocksetByLocksetId(Long locksetId)
    {
        return isLocksetMapper.deleteIsLocksetByLocksetId(locksetId);
    }

    @Override
    public Page<IsLocksetVO> getIsLocksetPage(Page<IsLockset> page, IsLockset isLockset) {
        return isLocksetMapper.getIsLocksetPage(page, isLockset);
    }
}
